*** DEMO.PRG by Int'l Computer Group, Inc.      301 670-7007    07/06/90
***
*** Library of functions for saving screens from within a CLIPPER program
*** for use in creating self running demos
*** Requires FUNCKY LIB, or replace the READS, PRINT, and CSRPUT functions
***
*** Use a SET KEY function to call MKDEMO to capture a screen to a database,
*** and another SET KEY for RSCR to redisplay a captured screen
***
*** Requires DEMO.DBF and DEMO.DBT also.

proc MKDEMO
  private nsel,sid,mscr,mr,mc
  mr=row()
  mc=col()
  nsel=ltrim(str(select()))
  select 0
  use demo
  save scre to mscr
  smsg("Enter screen ID")
  sid=space(10)
  reads(14,35,sid)
  if !empty(sid)
    appe blank
    repl id with upper(sid),scr with mscr
  endif
  use
  sele &nsel
  rest scre from mscr
  csrput(mr,mc)
  return

proc RSCR
  private nsel,x,mscr,i,mc,mr,fs
  mc=col()
  mr=row()
  fs=ltrim(str(filesize("demo.dbt")))
  nsel=ltrim(str(select()))
  select 0
  use demo
  save scre to mscr
  go top
  if !eof()
    decl ascr[reccount()]
    for x=1 to reccount()
      ascr[x]=id+str(recno(),5)
      skip
    next
    asort(ascr)
    do while .t.
      box(2,5,22,18)
      @ 22,7 say fs
      i=achoice(3,7,21,16,ascr)
      if i=0
        exit
      endif
      nrec=val(right(ascr[i],10))
      goto nrec
      rest scre from scr
      inkey(0)
    enddo
  endif
  use
  sele &nsel
  rest scre from mscr
  csrput(mr,mc)
  return

FUNC SMSG
  PARAMETERS _msg,_clr
  private _tmpclr,x
  h_pack()
  _tmpclr=standard()
  if pcount()<2
    _clr=31
  endif
  standard(_clr)
  h_pack()
  X=40-(LEN(TRIM(LEFT(_msg+SPACE(40),40)))/2)
  BOX(11,18,15,62)
  print(13,X,TRIM(_msg))
  standard(_tmpclr)
  RETURN(.t.)
